moSetGetConfigXml = {};

function moSetGetConfigXml:loadConfig(self)
	local path = getUserProfileAppPath();
	local file = path.."/multiOverlaySettings.xml";
	if not fileExists(file) then
		return false;
	end;
	local Xml = loadXMLFile("MultiOverlaySettings_XML", file, "MultiOverlay");
	moGeneralSettings.xml = Xml;
	if getXMLBool(Xml, "MultiOverlay.artDesign") ~= nil then moGuiMiniPDAsetGet.artDesign = getXMLBool(Xml, "MultiOverlay.artDesign");end;
	if getXMLBool(Xml, "MultiOverlay.newFruitNames.regFruitNames") ~= nil then moDefault.regNewFruitNames = getXMLBool(Xml, "MultiOverlay.newFruitNames.regFruitNames");end;
	if getXMLBool(Xml, "MultiOverlay.newStationNames.regStationNames") ~= nil then moDefault.regNewStationNames = getXMLBool(Xml, "MultiOverlay.newStationNames.regStationNames");end;
	if getXMLInt(Xml, "MultiOverlay.newStationNames.maxStationsProPage") then moDefault.maxStationsProPage = getXMLInt(Xml, "MultiOverlay.newStationNames.maxStationsProPage");end;
	if moDefault.maxStationsProPage <=2 then moDefault.maxStationsProPage = 14;end;
	moDefault.endStationPage = moDefault.maxStationsProPage;
	if getXMLBool(Xml, "MultiOverlay.loadDemandPage2") ~= nil then moDefault.loadDemandPage2 = getXMLBool(Xml, "MultiOverlay.loadDemandPage2");end;
	if getXMLInt(Xml, "MultiOverlay.updateInterval") then MultiOverlay.timerUpdate.interval = getXMLInt(Xml, "MultiOverlay.updateInterval");end;	
	if getXMLInt(Xml, "MultiOverlay.size") then moSetGetGui.pdaMenueSize = getXMLInt(Xml, "MultiOverlay.size")/1000;end;	
	if getXMLInt(Xml, "MultiOverlay.lastPage") then moSetGetGui.pdaActivePage = getXMLInt(Xml, "MultiOverlay.lastPage");end;
	if getXMLInt(Xml, "MultiOverlay.mapPriceSwitch") then moDefault.mapPriceSwitch = getXMLInt(Xml, "MultiOverlay.mapPriceSwitch");end;
	if getXMLInt(Xml, "MultiOverlay.mapFruitsSwitch") then moDefault.mapFruitsSwitch = getXMLInt(Xml, "MultiOverlay.mapFruitsSwitch");end;
	if getXMLBool(Xml, "MultiOverlay.adjustZoom") ~= nil then moSetGetGui.adjustZoom = getXMLBool(Xml, "MultiOverlay.adjustZoom");end;
	if getXMLBool(Xml, "MultiOverlay.combiBgaSilo") ~= nil then moGuiMiniPDAsetGet.combiBgaSilo = getXMLBool(Xml, "MultiOverlay.combiBgaSilo");end;
	if getXMLBool(Xml, "MultiOverlay.miniMap") ~= nil then moDefault.miniMap = getXMLBool(Xml, "MultiOverlay.miniMap");end;
	if getXMLBool(Xml, "MultiOverlay.helpText") ~= nil then moDefault.helpText = getXMLBool(Xml, "MultiOverlay.helpText");end;
	g_currentMission.ingameMap.isVisible = moDefault.miniMap;
	g_currentMission.showHelpText = moDefault.helpText;
	--if getXMLBool(Xml, "MultiOverlay.weatherTime") ~= nil then moDefault.weatherTime = getXMLBool(Xml, "MultiOverlay.weatherTime");end;
	--if not moDefault.weatherTime then
	--	g_currentMission.renderTime = false;
	--	g_currentMission.showWeatherForecast = false;
	--end;
	--if getXMLBool(Xml, "MultiOverlay.VI") ~= nil then moSetGetGui.pdaVI.on = getXMLBool(Xml, "MultiOverlay.VI");end;
	--if getXMLBool(Xml, "MultiOverlay.VIiconDesign") ~= nil then moSetGetGui.pdaVI.iconDesign = getXMLBool(Xml, "MultiOverlay.VIiconDesign");end;
	--if getXMLInt(Xml, "MultiOverlay.VIhideSwitch") then moSetGetGui.pdaVI.hideSwitch = getXMLInt(Xml, "MultiOverlay.VIhideSwitch");end;
	if getXMLFloat(Xml, "MultiOverlay.screenAspectRatio") then moSetGetGui.screenAspectRatio = getXMLFloat(Xml, "MultiOverlay.screenAspectRatio");end;
	if getXMLBool(Xml, "MultiOverlay.screenAspectRatioAuto") ~= nil then moSetGetGui.screenAspectRatioAuto = getXMLBool(Xml, "MultiOverlay.screenAspectRatioAuto");end;
	if moSetGetGui.screenAspectRatioAuto then
		if g_screenAspectRatio >= 1.3 and g_screenAspectRatio <= 1.4 then moSetGetGui.screenAspectRatio = 4.61;end;
		if g_screenAspectRatio >= 1.25 and g_screenAspectRatio <= 1.29 then moSetGetGui.screenAspectRatio = 4.8;end;
		if g_screenAspectRatio >= 1.5 then moSetGetGui.screenAspectRatio = 0;end;
	end;
	if getXMLInt(Xml, "MultiOverlay.multiFarmSilo") then moDefault.multiFarmSilo = getXMLInt(Xml, "MultiOverlay.multiFarmSilo");end;
	loadVI(self, Xml);
	loadPlaceable(self, Xml);
	return true;
end;

function loadPlaceable(self, Xml)	
	if moGeneralSettings.xml ~= nil then		
		local i=1;
		while true do
			local groupNameTag = ("MultiOverlay.placeable.mod(%d)"):format(i);
			local idx = getXMLInt(moGeneralSettings.xml, groupNameTag.."#id");
			if idx == nil then				
				break;
			end;
			if getXMLString(moGeneralSettings.xml, groupNameTag.."#slotType") and getXMLString(moGeneralSettings.xml, groupNameTag.."#xmlString") and getXMLString(moGeneralSettings.xml, groupNameTag.."#modType") then
				local slotType = string.lower(getXMLString(moGeneralSettings.xml, groupNameTag.."#slotType"));
				local xmlString = string.lower(getXMLString(moGeneralSettings.xml, groupNameTag.."#xmlString"));
				local modType = string.lower(getXMLString(moGeneralSettings.xml, groupNameTag.."#modType"));
				if string.find(xmlString, "placeableheaps") then
					if modType ~= "upk" then modType = "upk";end;
				end;				
				if modType == "upk" and moDefault.upkMod or modType == "fs" then
					if string.find(xmlString, ".xml") then --or modType == "ls" or modType == "other" then
						local displayName = modType.. i;						
						local category = "factory";
						if getXMLString(moGeneralSettings.xml, groupNameTag.."#displayName") then displayName = getXMLString(moGeneralSettings.xml, groupNameTag.."#displayName");end;
						if getXMLString(moGeneralSettings.xml, groupNameTag.."#category") then category = getXMLString(moGeneralSettings.xml, groupNameTag.."#category");end;					
						if string.find(xmlString, "placeableheaps") then
							if category ~= "heaps" then category = "heaps";end;							
						end;
						if category ~= "heaps" and category ~= "factory" and category ~= "trees" and category ~= "stock" then category = "factory";end;
						if slotType == "placeabletrees" then						
							table.insert(moDefaultPlaceable.trees, modType.. ",".. xmlString.. ",".. displayName.. ",".. category);
							table.insert(moDefaultPlaceable.loadXmlTrees, true);
							moDefaultPlaceable.searchTrees = moDefaultPlaceable.searchTrees+1;						
						end;
						if slotType == "placeablemods" then						
							table.insert(moDefaultPlaceable.mods, modType.. ",".. xmlString.. ",".. displayName.. ",".. category);
							table.insert(moDefaultPlaceable.loadXmlMods, true);
							moDefaultPlaceable.searchMods = moDefaultPlaceable.searchMods+1;						
						end;
						--if slotType == "placeableobjects" then						
						--	table.insert(moDefaultPlaceable.objects, modType.. " ".. xmlString.. " ".. displayName);
						--	table.insert(moDefaultPlaceable.loadXmlObjects, true)
						--	moDefaultPlaceable.searchObjects = moDefaultPlaceable.searchObjects+1;						
						--end;
						--if slotType == "greenhouse" then						
						--	table.insert(moDefaultPlaceable.greenHouse, modType.. " ".. xmlString.. " ".. displayName);
						--	table.insert(moDefaultPlaceable.loadXmlGreenHouse, true)
						--	moDefaultPlaceable.searchGreenHouse = moDefaultPlaceable.searchGreenHouse+1;						
						--end;
					else
						print("MultiOverlay Hud(placeable Error at...) !! check --> mod id=".. i.. "...xmlString")
					end;
				end;
			else
				print("MultiOverlay Hud(placeable Error at...) !! check --> mod id=".. i.. "...slotType,xmlString,modType")				
			end;
			i=i+1;
		end;
	end;
end;

function moSetGetConfigXml:loadSetXmlMiniPDAslots(self)		
	if moGeneralSettings.xml ~= nil then		
		local allPara = true;
		local i=0;
		local name = nil;
		while true do
			local xmlNameTag = ("MultiOverlay.miniPDA.slot(%d)"):format(i);
			local idx = getXMLInt(moGeneralSettings.xml, xmlNameTag.."#id");
			if idx == nil then
				if moGuiMiniPDAsetGet.slotsActive >= i then
					print("!!!! WARNING !!!! Found corrupt MultiOverlay Hud miniPDA slot id=".. i.. " name=nil");
					print("!!!! disable miniPDA (create your new) manipulate not xml settings !!!!");
					moGuiMiniPDAsetGet.slotsActive = 0;
					moGuiMiniPDAsetGet.isActive = false;
					moGuiMiniPDAsetGet.isKeySwitchActive = false;
					moGuiMiniPDAsetGet.keySwitchLast = 1;
				end;
				break;
			end;						
			if allPara then	
				allPara = false;
				if getXMLBool(moGeneralSettings.xml, xmlNameTag.."#isActive") ~= nil then moGuiMiniPDAsetGet.isActive = getXMLBool(moGeneralSettings.xml, xmlNameTag.."#isActive");end;
				if getXMLInt(moGeneralSettings.xml, xmlNameTag.."#slotsActive") then moGuiMiniPDAsetGet.slotsActive = getXMLInt(moGeneralSettings.xml, xmlNameTag.."#slotsActive");end;
				if getXMLInt(moGeneralSettings.xml, xmlNameTag.."#slotOpen") then moGuiMiniPDAsetGet.slotOpen = getXMLInt(moGeneralSettings.xml, xmlNameTag.."#slotOpen");end;
				if moGuiMiniPDAsetGet.isActive and moGuiMiniPDAsetGet.slotsActive == 0 or moGuiMiniPDAsetGet.slotsActive > moGuiMiniPDAsetGet.slotsMax then 
					moGuiMiniPDAsetGet.isActive = false;
					moGuiMiniPDAsetGet.slotsActive = 0;
					moGuiMiniPDAsetGet.slotOpen = 0;
				end;								
				if getXMLBool(moGeneralSettings.xml, xmlNameTag.."#keyMouseSwitch") ~= nil then moGuiMiniPDAsetGet.isKeySwitchActive = getXMLBool(moGeneralSettings.xml, xmlNameTag.."#keyMouseSwitch");end;				
				if moGuiMiniPDAsetGet.isKeySwitchActive and moGuiMiniPDAsetGet.slotOpen ~= 0 then moGuiMiniPDAsetGet.keySwitchLast = moGuiMiniPDAsetGet.slotOpen;end;
				if getXMLInt(moGeneralSettings.xml, xmlNameTag.."#alignment") then moGuiMiniPDAsetGet.alignment = getXMLInt(moGeneralSettings.xml, xmlNameTag.."#alignment");end;
				if getXMLBool(moGeneralSettings.xml, xmlNameTag.."#artDesignDistance") ~= nil then moGuiMiniPDAsetGet.artDesignDistance = getXMLBool(moGeneralSettings.xml, xmlNameTag.."#artDesignDistance");end;
				if getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#slotDistance") then					
					moGuiMiniPDAsetGet.slotDistance = getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#slotDistance");					
					moSetGetGui:refreshAlignment(self, false, false);
				end;
				if getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#zoomOutIn") then moGuiMiniPDAsetGet.zoomOutIn = getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#zoomOutIn");end;
				if getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#posX") then moGuiMiniPDAsetGet.posX = getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#posX");end;					
				if getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#posY") then moGuiMiniPDAsetGet.posY = getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#posY");end;
				if getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#openX") then moGuiMiniPDAsetGet.openX = getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#openX");end;
				if getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#openY") then moGuiMiniPDAsetGet.openY = getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#openY");end;
			else				
				if getXMLString(moGeneralSettings.xml, xmlNameTag.."#name") and string.find(moGuiMiniPDAsetGet.slotNameOn, getXMLString(moGeneralSettings.xml, xmlNameTag.."#name")) then
					name = getXMLString(moGeneralSettings.xml, xmlNameTag.."#name");
					if name == "weather" then moGuiMiniPDAsetGet.slotWeather = true;end;
					moGuiMiniPDAsetGet.slot[i] = name;
					if getXMLInt(moGeneralSettings.xml, xmlNameTag.."#switch") then moGuiMiniPDAsetGet.slotSwitch[i] = getXMLInt(moGeneralSettings.xml, xmlNameTag.."#switch");end;				
					if not string.find(moGuiMiniPDAsetGet.slotSwitchOn, name.. " ") then						
						moGuiMiniPDAsetGet.slotSwitch[i] = 0;					
					end;
					if getXMLInt(moGeneralSettings.xml, xmlNameTag.."#lengthDefault") then moGuiMiniPDAsetGet.lengthDefault[i] = getXMLInt(moGeneralSettings.xml, xmlNameTag.."#lengthDefault");end;
					if getXMLInt(moGeneralSettings.xml, xmlNameTag.."#maxProSwitch") then moGuiMiniPDAsetGet.maxProSwitch[i] = getXMLInt(moGeneralSettings.xml, xmlNameTag.."#maxProSwitch");end;	
					if getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#openX") then	moGuiMiniPDAsetGet.slotOpenX[i] = getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#openX");end;
					if not string.find(moGuiMiniPDAsetGet.slotOpenSlotNewPosOn, name) then						
						moGuiMiniPDAsetGet.slotOpenX[i] = 0;
						moGuiMiniPDAsetGet.slotOpenY[i] = 0;
					else
						if getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#openY") then moGuiMiniPDAsetGet.slotOpenY[i] = getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#openY");end;
						if moGuiMiniPDAsetGet.slotOpenX[i] <= 0.0001 then moGuiMiniPDAsetGet.slotOpenX[i] = moGuiMiniPDAsetGet.openX;end;
						if moGuiMiniPDAsetGet.slotOpenY[i] <= 0.0001 then moGuiMiniPDAsetGet.slotOpenY[i] = moGuiMiniPDAsetGet.openY;end;
					end;					
					if getXMLBool(moGeneralSettings.xml, xmlNameTag.."#closeOpenForeignHuds") ~= nil then moGuiMiniPDAsetGet.slotCloseOpenForeignHuds[i] = getXMLBool(moGeneralSettings.xml, xmlNameTag.."#closeOpenForeignHuds");end;
					if not string.find(moGuiMiniPDAsetGet.slotCloseOpenForeignHudsOn, name.. " ") then						
						moGuiMiniPDAsetGet.slotCloseOpenForeignHuds[i] = false;
					end;
					if getXMLBool(moGeneralSettings.xml, xmlNameTag.."#closeOpenHud") ~= nil then moGuiMiniPDAsetGet.slotCloseOpenHud[i] = getXMLBool(moGeneralSettings.xml, xmlNameTag.."#closeOpenHud");end;											
					moGuiMiniPDAsetGet.slotCloseOpenForeignHuds[i] = false; --not active,set default					
					
					if getXMLBool(moGeneralSettings.xml, xmlNameTag.."#warning") ~= nil then moGuiMiniPDAsetGet.slotWarning[i] = getXMLBool(moGeneralSettings.xml, xmlNameTag.."#warning");end;
					if not string.find(moGuiMiniPDAsetGet.slotWarningOn, name.. " ") then						
						moGuiMiniPDAsetGet.slotWarning[i] = false;						
					end;
					if getXMLBool(moGeneralSettings.xml, xmlNameTag.."#warningSound") ~= nil then moGuiMiniPDAsetGet.slotWarningSound[i] = getXMLBool(moGeneralSettings.xml, xmlNameTag.."#warningSound");end;
					moGuiMiniPDAsetGet.slotWarningSound[i] = false; --not active,set default
					if getXMLBool(moGeneralSettings.xml, xmlNameTag.."#warningLiveTicker") ~= nil then moGuiMiniPDAsetGet.slotWarningLiveTicker[i] = getXMLBool(moGeneralSettings.xml, xmlNameTag.."#warningLiveTicker");end;
					moGuiMiniPDAsetGet.slotWarningLiveTicker[i] = false; --not active,set default
				else
					moGuiMiniPDAsetGet.slotsActive = 0;
					moGuiMiniPDAsetGet.isActive = false;
					moGuiMiniPDAsetGet.isKeySwitchActive = false;
					moGuiMiniPDAsetGet.keySwitchLast = 1;
					print("!!!! WARNING !!!! Found corrupt MultiOverlay Hud miniPDA slot id=".. i.. " name=".. tostring(name));
					print("!!!! Refresh MultiOverlay Hud miniPDA................set nil");									
				end;				
			end;
			i=i+1;
        end				
	end;	
end;

function loadVI(self, Xml, xmlNameTag)
	if moGeneralSettings.xml ~= nil then
		local a = 0;		
		local xmlNameTag = ("clientSettings.vehicleInspector.values(%d)"):format(a);
		if getXMLBool(moGeneralSettings.xml, xmlNameTag.."#on") ~= nil then moSetGetGui.pdaVI.on = getXMLBool(moGeneralSettings.xml, xmlNameTag.."#on");end;
		if getXMLBool(moGeneralSettings.xml, xmlNameTag.."#iconDesign") ~= nil then moSetGetGui.pdaVI.iconDesign = getXMLBool(moGeneralSettings.xml, xmlNameTag.."#iconDesign");end;
		if getXMLBool(moGeneralSettings.xml, xmlNameTag.."#speedDisplay") ~= nil then moSetGetGui.pdaVI.speedDisplay = getXMLBool(moGeneralSettings.xml, xmlNameTag.."#speedDisplay");end;
		if getXMLBool(moGeneralSettings.xml, xmlNameTag.."#fieldDisplay") ~= nil then moSetGetGui.pdaVI.fieldDisplay = getXMLBool(moGeneralSettings.xml, xmlNameTag.."#fieldDisplay");end;
		if getXMLBool(moGeneralSettings.xml, xmlNameTag.."#vehicleDisplay") ~= nil then moSetGetGui.pdaVI.vehicleDisplay = getXMLBool(moGeneralSettings.xml, xmlNameTag.."#vehicleDisplay");end;
		if getXMLBool(moGeneralSettings.xml, xmlNameTag.."#backGround") ~= nil then moSetGetGui.pdaVI.backGround = getXMLBool(moGeneralSettings.xml, xmlNameTag.."#backGround");end;
		if getXMLBool(moGeneralSettings.xml, xmlNameTag.."#distanceLine") ~= nil then moSetGetGui.pdaVI.distanceLine = getXMLBool(moGeneralSettings.xml, xmlNameTag.."#distanceLine");end;
		if getXMLInt(moGeneralSettings.xml, xmlNameTag.."#vehicleName") then moSetGetGui.pdaVI.vehicleName = getXMLInt(moGeneralSettings.xml, xmlNameTag.."#vehicleName");end;
		if getXMLInt(moGeneralSettings.xml, xmlNameTag.."#playerName") then moSetGetGui.pdaVI.fullPlayerName = getXMLInt(moGeneralSettings.xml, xmlNameTag.."#playerName");end;
		if getXMLInt(moGeneralSettings.xml, xmlNameTag.."#moreInfo") then moSetGetGui.pdaVI.seeMoreInfo = getXMLInt(moGeneralSettings.xml, xmlNameTag.."#moreInfo");end;
		if getXMLInt(moGeneralSettings.xml, xmlNameTag.."#hideSwitch") then moSetGetGui.pdaVI.hideSwitch = getXMLInt(moGeneralSettings.xml, xmlNameTag.."#hideSwitch");end;
		if getXMLInt(moGeneralSettings.xml, xmlNameTag.."#autoPos") then moSetGetGui.pdaVI.autoPos = getXMLInt(moGeneralSettings.xml, xmlNameTag.."#autoPos");end;
		if moSetGetGui.pdaVI.autoPos == 1 then moSetGetGui.pdaVI.upDisplay = true;end;
		if getXMLInt(moGeneralSettings.xml, xmlNameTag.."#compactDisplay") then moSetGetGui.pdaVI.compactDisplay = getXMLInt(moGeneralSettings.xml, xmlNameTag.."#compactDisplay");end;
		if getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#size") then moSetGetGui.pdaVI.size = getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#size");end;
		if getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#distance") then moSetGetGui.pdaVI.distance = getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#distance");end;
		if getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#zoomOutIn") then moSetGetGui.pdaVI.zoomOutInVI = getXMLFloat(moGeneralSettings.xml, xmlNameTag.."#zoomOutIn");end;
		if moSetGetGui.pdaVI.iconDesign then
			if not moSetGetGui.pdaVI.speedDisplay then moSetGetGui.pdaVI.speedDisplay = true;end;
		end;
	end;
end;

function moSetGetConfigXml:saveConfig(self)
	local file = MultiOverlayV2.settingsDir.. "clientSettings.xml";
	local Xml = createXMLFile("MultiOverlayV2_XML", file, "clientSettings");	
	local xmlNameTag = "clientSettings";
	if Xml ~= nil then		
		setXMLBool(Xml, xmlNameTag.. ".artDesign", moGuiMiniPDAsetGet.artDesign);
		local artDesign = false;
		local replaceDirFile;
		if moGuiMiniPDAsetGet.artDesign then
			replaceDirFile = string.gsub(moGuiMiniPDAsetGet.designDir, path, "");
			if string.len(replaceDirFile) >= 2 then artDesign = true;end;
		end;			
		if artDesign then
			setXMLString(Xml, xmlNameTag.. ".artDesignDirAndXML", replaceDirFile.. moGuiMiniPDAsetGet.designName);
		else
			setXMLString(Xml, xmlNameTag.. ".artDesignDirAndXML", "optionalDir/xmlfile (without .xml)");
		end;
		setXMLInt(Xml, xmlNameTag.. ".updateInterval", MultiOverlayV2.timerUpdate.interval);
		setXMLInt(Xml, xmlNameTag.. ".size", moSetGetGui.pdaMenueSize*1000);
		setXMLInt(Xml, xmlNameTag.. ".lastPage", moSetGetGui.pdaActivePage);
		setXMLInt(Xml, xmlNameTag.. ".mapPriceSwitch", moDefault.mapPriceSwitch);
		setXMLInt(Xml, xmlNameTag.. ".mapFruitsSwitch", moDefault.mapFruitsSwitch);
		setXMLBool(Xml, xmlNameTag.. ".loadDemandPage2", moDefault.loadDemandPage2);
		setXMLBool(Xml, xmlNameTag.. ".miniMap", moDefault.miniMap);
		setXMLBool(Xml, xmlNameTag.. ".helpText", moDefault.helpText);
		--setXMLBool(Xml, "MultiOverlay.weatherTime", moDefault.weatherTime);
		setXMLBool(Xml, xmlNameTag.. ".adjustZoom", moSetGetGui.adjustZoom);
		setXMLBool(Xml, xmlNameTag.. ".combiBgaSilo", moGuiMiniPDAsetGet.combiBgaSilo);
		--setXMLBool(Xml, "MultiOverlay.VI", moSetGetGui.pdaVI.on);
		--setXMLBool(Xml, "MultiOverlay.VIiconDesign", moSetGetGui.pdaVI.iconDesign);
		--setXMLInt(Xml, "MultiOverlay.VIhideSwitch", moSetGetGui.pdaVI.hideSwitch);
		setXMLBool(Xml, xmlNameTag.. ".screenAspectRatioAuto", moSetGetGui.screenAspectRatioAuto);
		setXMLFloat(Xml, xmlNameTag.. ".screenAspectRatio", moSetGetGui.screenAspectRatio);
		setXMLInt(Xml, xmlNameTag.. ".multiFarmSilo", moDefault.multiFarmSilo);
		setXMLBool(Xml, xmlNameTag.. ".newFruitNames.regFruitNames", moDefault.regNewFruitNames);
		setXMLBool(Xml, xmlNameTag.. ".newStationNames.regStationNames", moDefault.regNewStationNames);
		setXMLInt(Xml, xmlNameTag.. ".newStationNames.maxStationsProPage", moDefault.maxStationsProPage);		
		saveNewXmlFruitNames(self, Xml);		
		saveNewXmlStationNames(self, Xml);			
		saveMiniPDAslots(self, Xml);
		saveVI(self, Xml);
		savePlaceable(self, Xml);
		saveXMLFile(Xml);		
	else
		print("!!!! WARNING !!!! MultiOverlay Hud save file error "..file);
	end;	
end;

function saveMiniPDAslots(self, Xml)			
	local allPara = true;
	for a=0, moGuiMiniPDAsetGet.slotsActive do				
		local xmlNameTag = ("MultiOverlay.miniPDA.slot(%d)"):format(a);
		if allPara then
			allPara = false;
			setXMLInt(Xml, xmlNameTag.."#id", a);
			if moGuiMiniPDAsetGet.isActive and moGuiMiniPDAsetGet.slotsActive == 0 then
				setXMLBool(Xml, xmlNameTag.."#isActive", false);
			else
				setXMLBool(Xml, xmlNameTag.."#isActive", moGuiMiniPDAsetGet.isActive);	
			end;			
			setXMLInt(Xml, xmlNameTag.."#slotsActive", moGuiMiniPDAsetGet.slotsActive);			
			setXMLInt(Xml, xmlNameTag.."#slotOpen", moGuiMiniPDAsetGet.slotOpen);			
			setXMLBool(Xml, xmlNameTag.."#keyMouseSwitch", moGuiMiniPDAsetGet.isKeySwitchActive);
			setXMLInt(Xml, xmlNameTag.."#alignment", moGuiMiniPDAsetGet.alignment);
			setXMLFloat(Xml, xmlNameTag.."#slotDistance", moGuiMiniPDAsetGet.slotDistance);
			if moGuiMiniPDAsetGet.artDesignDistance and not moGuiMiniPDAsetGet.artDesign then
				setXMLBool(Xml, xmlNameTag.."#artDesignDistance", false);
			else
				setXMLBool(Xml, xmlNameTag.."#artDesignDistance", moGuiMiniPDAsetGet.artDesignDistance);
			end;
			setXMLFloat(Xml, xmlNameTag.."#zoomOutIn", moGuiMiniPDAsetGet.zoomOutIn);			
			setXMLFloat(Xml, xmlNameTag.."#posX", moGuiMiniPDAsetGet.posX);
			setXMLFloat(Xml, xmlNameTag.."#posY", moGuiMiniPDAsetGet.posY);
			setXMLFloat(Xml, xmlNameTag.."#openX", moGuiMiniPDAsetGet.openX);
			setXMLFloat(Xml, xmlNameTag.."#openY", moGuiMiniPDAsetGet.openY);
		else			
			setXMLInt(Xml, xmlNameTag.."#id", a);
			setXMLString(Xml, xmlNameTag.."#name", moGuiMiniPDAsetGet.slot[a]);
			local slotSwitch = tonumber(moGuiMiniPDAsetGet.slotSwitch[a]);
			if string.find(moGuiMiniPDAsetGet.slotSwitchOn, moGuiMiniPDAsetGet.slot[a]) then
				if slotSwitch == 0 then slotSwitch = 1;end;
			end;			
			setXMLInt(Xml, xmlNameTag.."#switch", slotSwitch);			
			setXMLBool(Xml, xmlNameTag.."#warning", moGuiMiniPDAsetGet.slotWarning[a]);
			setXMLBool(Xml, xmlNameTag.."#warningSound", moGuiMiniPDAsetGet.slotWarningSound[a]);
			setXMLBool(Xml, xmlNameTag.."#warningLiveTicker", moGuiMiniPDAsetGet.slotWarningSound[a]);			
			if moGuiMiniPDAsetGet.slotOpenX[a] <= 0.0001 then  moGuiMiniPDAsetGet.slotOpenX[a] = moGuiMiniPDAsetGet.openX;end;
			if moGuiMiniPDAsetGet.slotOpenY[a] <= 0.0001 then  moGuiMiniPDAsetGet.slotOpenY[a] = moGuiMiniPDAsetGet.openY;end;
			setXMLFloat(Xml, xmlNameTag.."#openX", moGuiMiniPDAsetGet.slotOpenX[a]);
			setXMLFloat(Xml, xmlNameTag.."#openY", moGuiMiniPDAsetGet.slotOpenY[a]);
			setXMLBool(Xml, xmlNameTag.."#closeOpenHud", moGuiMiniPDAsetGet.slotCloseOpenHud[a]);
			setXMLBool(Xml, xmlNameTag.."#closeOpenForeignHuds", moGuiMiniPDAsetGet.slotCloseOpenForeignHuds[a]);
			setXMLInt(Xml, xmlNameTag.."#maxProSwitch", moGuiMiniPDAsetGet.maxProSwitch[a]);
			setXMLInt(Xml, xmlNameTag.."#lengthDefault", moGuiMiniPDAsetGet.lengthDefault[a]);
		end;
	end;	
end;

function savePlaceable(self, Xml)	
	local b = 0;
	if moDefaultPlaceable.searchTrees > 0 then
		for a=1, moDefaultPlaceable.searchTrees do
			if moDefaultPlaceable.loadXmlTrees[a] then
				local groupNameTag = ("MultiOverlay.placeable.mod(%d)"):format(b);
				setXMLInt(Xml, groupNameTag.."#id", b);
				local splitString = Utils.splitString(",", moDefaultPlaceable.trees[a]);
				setXMLString(Xml, groupNameTag.."#modType", splitString[1]);
				setXMLString(Xml, groupNameTag.."#slotType", "placeableTrees");
				setXMLString(Xml, groupNameTag.."#xmlString", splitString[2]);
				setXMLString(Xml, groupNameTag.."#displayName", splitString[3]);
				setXMLString(Xml, groupNameTag.."#category", splitString[4]);
				b = b+1;
			end;
		end;
	end;
	--if moDefaultPlaceable.searchObjects > 0 then
	--	for a=1, moDefaultPlaceable.searchObjects do
	--		if moDefaultPlaceable.loadXmlObjects[a] then
	--			local groupNameTag = ("MultiOverlay.placeable.mod(%d)"):format(b);
	--			setXMLInt(Xml, groupNameTag.."#id", b);
	--			local splitString = Utils.splitString(" ", moDefaultPlaceable.objects[a]);
	--			setXMLString(Xml, groupNameTag.."#modType", splitString[1]);
	--			setXMLString(Xml, groupNameTag.."#slotType", "placeableObjects");
	--			setXMLString(Xml, groupNameTag.."#xmlString", splitString[2]);
	--			setXMLString(Xml, groupNameTag.."#displayName", splitString[3]);
	--			b = b+1;
	--		end;
	--	end;
	--end;
	if moDefaultPlaceable.searchMods > 0 then
		for a=1, moDefaultPlaceable.searchMods do
			if moDefaultPlaceable.loadXmlMods[a] then
				local groupNameTag = ("MultiOverlay.placeable.mod(%d)"):format(b);
				setXMLInt(Xml, groupNameTag.."#id", b);
				local splitString = Utils.splitString(",", moDefaultPlaceable.mods[a]);
				setXMLString(Xml, groupNameTag.."#modType", splitString[1]);
				setXMLString(Xml, groupNameTag.."#slotType", "placeableMods");
				setXMLString(Xml, groupNameTag.."#xmlString", splitString[2]);
				setXMLString(Xml, groupNameTag.."#displayName", splitString[3]);
				setXMLString(Xml, groupNameTag.."#category", splitString[4]);
				b = b+1;
			end;
		end;
	end;
	--if moDefaultPlaceable.searchGreenHouse > 0 then
	--	for a=1, moDefaultPlaceable.searchGreenHouse do
	--		if moDefaultPlaceable.loadXmlGreenHouse[a] then
	--			local groupNameTag = ("MultiOverlay.placeable.mod(%d)"):format(b);
	--			setXMLInt(Xml, groupNameTag.."#id", b);
	--			local splitString = Utils.splitString(" ", moDefaultPlaceable.greenHouse[a]);
	--			setXMLString(Xml, groupNameTag.."#modType", splitString[1]);
	--			setXMLString(Xml, groupNameTag.."#slotType", "greenHouse");
	--			setXMLString(Xml, groupNameTag.."#xmlString", splitString[2]);
	--			setXMLString(Xml, groupNameTag.."#displayName", splitString[3]);
	--			b = b+1;
	--		end;
	--	end;
	--end;
end;

function saveVI(self, Xml)
	local a = 0;		
	local xmlNameTag = ("clientSettings.vehicleInspector.values(%d)"):format(a);
	--setXMLInt(Xml, xmlNameTag.."#id", a);
	setXMLBool(Xml, xmlNameTag.."#on", moSetGetGui.pdaVI.on);
	setXMLBool(Xml, xmlNameTag.."#iconDesign", moSetGetGui.pdaVI.iconDesign);
	setXMLBool(Xml, xmlNameTag.."#speedDisplay", moSetGetGui.pdaVI.speedDisplay);
	setXMLBool(Xml, xmlNameTag.."#fieldDisplay", moSetGetGui.pdaVI.fieldDisplay);
	setXMLBool(Xml, xmlNameTag.."#vehicleDisplay", moSetGetGui.pdaVI.vehicleDisplay);
	setXMLBool(Xml, xmlNameTag.."#backGround", moSetGetGui.pdaVI.backGround);
	setXMLBool(Xml, xmlNameTag.."#distanceLine", moSetGetGui.pdaVI.distanceLine);
	setXMLBool(Xml, xmlNameTag.."#upDisplay", moSetGetGui.pdaVI.upDisplay);
	setXMLInt(Xml, xmlNameTag.."#vehicleName", moSetGetGui.pdaVI.vehicleName);
	setXMLInt(Xml, xmlNameTag.."#playerName", moSetGetGui.pdaVI.fullPlayerName);
	setXMLInt(Xml, xmlNameTag.."#moreInfo", moSetGetGui.pdaVI.seeMoreInfo);
	setXMLInt(Xml, xmlNameTag.."#hideSwitch", moSetGetGui.pdaVI.hideSwitch);
	setXMLInt(Xml, xmlNameTag.."#autoPos", moSetGetGui.pdaVI.autoPos);	
	setXMLInt(Xml, xmlNameTag.."#compactDisplay", moSetGetGui.pdaVI.compactDisplay);
	setXMLFloat(Xml, xmlNameTag.."#size", moSetGetGui.pdaVI.size);
	setXMLFloat(Xml, xmlNameTag.."#distance", moSetGetGui.pdaVI.distance);
	setXMLFloat(Xml, xmlNameTag.."#zoomOutIn", moSetGetGui.pdaVI.zoomOutInVI);
	setXMLInt(Xml, xmlNameTag.."#autoPos", moSetGetGui.pdaVI.autoPos);
end;

function saveNewXmlFruitNames(self, Xml)	
	if moFillTypesNewName ~= nil then		
		local a = 0;		
		local groupNewFruitNameTag = ("MultiOverlay.newFruitNames.name(%d)"):format(a);
		setXMLInt(Xml, groupNewFruitNameTag.."#id", a);
		setXMLString(Xml, groupNewFruitNameTag.."#oldName", "fruitName");
		setXMLString(Xml, groupNewFruitNameTag.."#newName", "fruitName");		
		a = a+1;		
		function setIndex(_index)			
			if _index ~= nil and moFillTypesNewName[_index] ~= nil and moFillTypesNewName[_index].oldName ~= nil then				
				groupNewFruitNameTag = ("MultiOverlay.newFruitNames.name(%d)"):format(a);
				setXMLInt(Xml, groupNewFruitNameTag.."#id", a);
				setXMLString(Xml, groupNewFruitNameTag.."#oldName", moFillTypesNewName[_index].oldName);
				setXMLString(Xml, groupNewFruitNameTag.."#newName", moFillTypesNewName[_index].newName);
				a = a+1;
			end;			
		end
		table.foreach(moFillTypesNewName, setIndex);				
	end;
end;

function saveNewXmlStationNames(self, Xml)	
	if moStationesNewName ~= nil then		
		local a = 0;		
		local groupNewStationNameTag = ("MultiOverlay.newStationNames.name(%d)"):format(a);
		setXMLInt(Xml, groupNewStationNameTag.."#id", a);
		setXMLString(Xml, groupNewStationNameTag.."#oldName", "stationName");
		setXMLString(Xml, groupNewStationNameTag.."#newName", "stationName");		
		a = a+1;		
		function setIndex(_index)			
			if _index ~= nil and moStationesNewName[_index] ~= nil and moStationesNewName[_index].oldName ~= nil then				
				groupNewStationNameTag = ("MultiOverlay.newStationNames.name(%d)"):format(a);
				setXMLInt(Xml, groupNewStationNameTag.."#id", a);
				setXMLString(Xml, groupNewStationNameTag.."#oldName", moStationesNewName[_index].oldName);
				setXMLString(Xml, groupNewStationNameTag.."#newName", moStationesNewName[_index].newName);
				a = a+1;
			end;			
		end
		table.foreach(moStationesNewName, setIndex);			
	end;	
end;